;++ BUILD Version: 0001 // Increment this if a change has global effects --

;****************************************************************************\
;*									       *
;*  ddeml.h -	 DDEML API header file					       *
;*									       *
;*		 Version 3.10						       *
;*									       *
;*		 Copyright (c) 1993-1998, Microsoft Corp.  All rights reserved.*
;*									       *
;\****************************************************************************

; the following structure is for use with XTYP_WILDCONNECT processing.

struc	HSZPAIR
	hszSvc			dd ?
	hszTopic		dd ?
ends

; The following structure is used by DdeConnect() and DdeConnectList() and
;   by XTYP_CONNECT and XTYP_WILDCONNECT callbacks.

struc	CONVCONTEXT
	cb			dd ?		; set to sizeof(CONVCONTEXT)
	wFlags			dd ?		; none currently defined.
	wCountryID		dd ?		; country code for topic/item strings used.
	iCodePage		dd ?		; codepage used for topic/item strings.
	dwLangID		dd ?		; language ID for topic/item strings.
	dwSecurity		dd ?		; Private security code.
	qos			SECURITY_QUALITY_OF_SERVICE ? ; client side's quality of service
ends

; The following structure is used by DdeQueryConvInfo():

struc	CONVINFO
	cb			dd ?		; sizeof(CONVINFO)
	hUser			dd ?		; user specified field
	hConvPartner		dd ?		; hConv on other end or 0 if non-ddemgr partner
	hszSvcPartner		dd ?		; app name of partner if obtainable
	hszServiceReq		dd ?		; AppName requested for connection
	hszTopic		dd ?		; Topic name for conversation
	hszItem 		dd ?		; transaction item name or NULL if quiescent
	wFmt			dd ?		; transaction format or NULL if quiescent
	wType			dd ?		; XTYP_ for current transaction
	wStatus 		dd ?		; ST_ constant for current conversation
	wConvst 		dd ?		; XST_ constant for current transaction
	wLastError		dd ?		; last transaction error.
	hConvList		dd ?		; parent hConvList if this conversation is in a list
	ConvCtxt		CONVCONTEXT ?	; conversation context
	hwnd			dd ?		; window handle for this conversation
	hwndPartner		dd ?		; partner window handle for this conversation
ends

;**** conversation states (usState) ****

XST_NULL			= 0  ; quiescent states
XST_INCOMPLETE			= 1
XST_CONNECTED			= 2
XST_INIT1			= 3  ; mid-initiation states
XST_INIT2			= 4
XST_REQSENT			= 5  ; active conversation states
XST_DATARCVD			= 6
XST_POKESENT			= 7
XST_POKEACKRCVD 		= 8
XST_EXECSENT			= 9
XST_EXECACKRCVD 		= 10
XST_ADVSENT			= 11
XST_UNADVSENT			= 12
XST_ADVACKRCVD			= 13
XST_UNADVACKRCVD		= 14
XST_ADVDATASENT 		= 15
XST_ADVDATAACKRCVD		= 16

; used in LOWORD(dwData1) of XTYP_ADVREQ callbacks...
CADV_LATEACK			= 0FFFFh

;**** conversation status bits (fsStatus) ****

ST_CONNECTED			= 00001h
ST_ADVISE			= 00002h
ST_ISLOCAL			= 00004h
ST_BLOCKED			= 00008h
ST_CLIENT			= 00010h
ST_TERMINATED			= 00020h
ST_INLIST			= 00040h
ST_BLOCKNEXT			= 00080h
ST_ISSELF			= 00100h

; DDE constants for wStatus field

DDE_FACK			= 08000h
DDE_FBUSY			= 04000h
DDE_FDEFERUPD			= 04000h
DDE_FACKREQ			= 08000h
DDE_FRELEASE			= 02000h
DDE_FREQUESTED			= 01000h
DDE_FAPPSTATUS			= 000fh
DDE_FNOTPROCESSED		= 00000h

DDE_FACKRESERVED		= (not(DDE_FACK + DDE_FBUSY + DDE_FAPPSTATUS))
DDE_FADVRESERVED		= (not(DDE_FACKREQ + DDE_FDEFERUPD))
DDE_FDATRESERVED		= (not(DDE_FACKREQ + DDE_FRELEASE + DDE_FREQUESTED))
DDE_FPOKRESERVED		= (not(DDE_FRELEASE))

;**** message filter hook types ****

MSGF_DDEMGR			= 08001h

;**** codepage constants ***

CP_WINANSI			= 1004	  ; default codepage for windows & old DDE convs.
CP_WINUNICODE			= 1200
CP_WINNEUTRAL			= CP_WINANSI

;**** transaction types ****

XTYPF_NOBLOCK			= 00002h  ; CBR_BLOCK will not work
XTYPF_NODATA			= 00004h  ; DDE_FDEFERUPD
XTYPF_ACKREQ			= 00008h  ; DDE_FACKREQ

XCLASS_MASK			= 0FC00h
XCLASS_BOOL			= 01000h
XCLASS_DATA			= 02000h
XCLASS_FLAGS			= 04000h
XCLASS_NOTIFICATION		= 08000h

XTYP_ERROR			= (00000h + XCLASS_NOTIFICATION + XTYPF_NOBLOCK)
XTYP_ADVDATA			= (00010h + XCLASS_FLAGS)
XTYP_ADVREQ			= (00020h + XCLASS_DATA + XTYPF_NOBLOCK )
XTYP_ADVSTART			= (00030h + XCLASS_BOOL)
XTYP_ADVSTOP			= (00040h + XCLASS_NOTIFICATION)
XTYP_EXECUTE			= (00050h + XCLASS_FLAGS)
XTYP_CONNECT			= (00060h + XCLASS_BOOL + XTYPF_NOBLOCK)
XTYP_CONNECT_CONFIRM		= (00070h + XCLASS_NOTIFICATION + XTYPF_NOBLOCK)
XTYP_XACT_COMPLETE		= (00080h + XCLASS_NOTIFICATION)
XTYP_POKE			= (00090h + XCLASS_FLAGS)
XTYP_REGISTER			= (000A0h + XCLASS_NOTIFICATION + XTYPF_NOBLOCK)
XTYP_REQUEST			= (000B0h + XCLASS_DATA)
XTYP_DISCONNECT 		= (000C0h + XCLASS_NOTIFICATION + XTYPF_NOBLOCK)
XTYP_UNREGISTER 		= (000D0h + XCLASS_NOTIFICATION + XTYPF_NOBLOCK)
XTYP_WILDCONNECT		= (000E0h + XCLASS_DATA + XTYPF_NOBLOCK)

XTYP_MASK			= 000F0h
XTYP_SHIFT			= 4  ; shift to turn XTYP_ into an index

;**** Timeout constants ****

TIMEOUT_ASYNC			= 0FFFFFFFFh

;**** Transaction ID constants ****

QID_SYNC			= 0FFFFFFFFh

;***** public strings used in DDE *****

SZDDESYS_TOPIC			equ <'System', 0>
SZDDESYS_ITEM_TOPICS		equ <'Topics', 0>
SZDDESYS_ITEM_SYSITEMS		equ <'SysItems', 0>
SZDDESYS_ITEM_RTNMSG		equ <'ReturnMessage', 0>
SZDDESYS_ITEM_STATUS		equ <'Status', 0>
SZDDESYS_ITEM_FORMATS		equ <'Formats', 0>
SZDDESYS_ITEM_HELP		equ <'Help', 0>
SZDDE_ITEM_ITEMLIST		equ <'TopicItemList', 0>

CBR_BLOCK			= (0ffffffffh)

; API entry point

proctype FNCALLBACK :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword

; DLL registration functions

procdesc DdeInitializeA :dword, :dword, :dword, :dword

DdeInitialize			equ <DdeInitializeA>

;
; Callback filter flags for use with standard apps.
;

CBF_FAIL_SELFCONNECTIONS	= 000001000h
CBF_FAIL_CONNECTIONS		= 000002000h
CBF_FAIL_ADVISES		= 000004000h
CBF_FAIL_EXECUTES		= 000008000h
CBF_FAIL_POKES			= 000010000h
CBF_FAIL_REQUESTS		= 000020000h
CBF_FAIL_ALLSVRXACTIONS 	= 00003f000h

CBF_SKIP_CONNECT_CONFIRMS	= 000040000h
CBF_SKIP_REGISTRATIONS		= 000080000h
CBF_SKIP_UNREGISTRATIONS	= 000100000h
CBF_SKIP_DISCONNECTS		= 000200000h
CBF_SKIP_ALLNOTIFICATIONS	= 0003c0000h

;
; Application command flags
;
APPCMD_CLIENTONLY		= 000000010h
APPCMD_FILTERINITS		= 000000020h
APPCMD_MASK			= 000000FF0h

;
; Application classification flags
;
APPCLASS_STANDARD		= 000000000h
APPCLASS_MASK			= 00000000Fh

procdesc DdeUninitialize :dword

;
; conversation enumeration functions
;

procdesc DdeConnectList :dword, :dword, :dword, :dword, :dword
procdesc DdeQueryNextServer :dword, :dword
procdesc DdeDisconnectList :dword

;
; conversation control functions
;

procdesc DdeConnect :dword, :dword, :dword, :dword
procdesc DdeDisconnect :dword
procdesc DdeReconnect :dword, :dword
procdesc DdeQueryConvInfo :dword, :dword, :dword, :dword
procdesc DdeSetUserHandle :dword, :dword, :dword
procdesc DdeAbandonTransaction :dword, :dword, :dword

;
; app server interface functions
;

procdesc DdePostAdvise :dword, :dword, :dword
procdesc DdeEnableCallback :dword, :dword, :dword
procdesc DdeImpersonateClient :dword

EC_ENABLEALL			= 0
EC_ENABLEONE			= ST_BLOCKNEXT
EC_DISABLE			= ST_BLOCKED
EC_QUERYWAITING 		= 2


procdesc DdeNameService :dword, :dword, :dword, :dword

DNS_REGISTER			= 00001h
DNS_UNREGISTER			= 00002h
DNS_FILTERON			= 00004h
DNS_FILTEROFF			= 00008h

;
; app client interface functions
;

procdesc DdeClientTransaction :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword

;
; data transfer functions
;

procdesc DdeCreateDataHandle :dword, :dword, :dword, :dword, :dword, :dword, :dword
procdesc DdeAddData :dword, :dword, :dword, :dword
procdesc DdeGetData :dword, :dword, :dword, :dword
procdesc DdeAccessData :dword, :dword
procdesc DdeUnaccessData :dword
procdesc DdeFreeDataHandle :dword

HDATA_APPOWNED			= 00001h

procdesc DdeGetLastError :dword

DMLERR_NO_ERROR 		= 0	  ; must be 0

DMLERR_FIRST			= 04000h

DMLERR_ADVACKTIMEOUT		= 04000h
DMLERR_BUSY			= 04001h
DMLERR_DATAACKTIMEOUT		= 04002h
DMLERR_DLL_NOT_INITIALIZED	= 04003h
DMLERR_DLL_USAGE		= 04004h
DMLERR_EXECACKTIMEOUT		= 04005h
DMLERR_INVALIDPARAMETER 	= 04006h
DMLERR_LOW_MEMORY		= 04007h
DMLERR_MEMORY_ERROR		= 04008h
DMLERR_NOTPROCESSED		= 04009h
DMLERR_NO_CONV_ESTABLISHED	= 0400h
DMLERR_POKEACKTIMEOUT		= 0400h
DMLERR_POSTMSG_FAILED		= 0400h
DMLERR_REENTRANCY		= 0400h
DMLERR_SERVER_DIED		= 0400h
DMLERR_SYS_ERROR		= 0400h
DMLERR_UNADVACKTIMEOUT		= 04010h
DMLERR_UNFOUND_QUEUE_ID 	= 04011h

DMLERR_LAST			= 04011h

procdesc DdeCreateStringHandleA :dword, :dword, :dword
procdesc DdeQueryStringA :dword, :dword, :dword, :dword, :dword

DdeCreateStringHandle		equ <DdeCreateStringHandleA>
DdeQueryString			equ <DdeQueryStringA>

procdesc DdeFreeStringHandle :dword, :dword
procdesc DdeKeepStringHandle :dword, :dword
procdesc DdeCmpStringHandles :dword, :dword

;
; DDEML public debugging header file info
;

struc	DDEML_MSG_HOOK_DATA			; new for NT
	uiLo			dd ?		; unpacked lo and hi parts of lParam
	uiHi			dd ?
	cbData			dd ?		; amount of data in message, if any. May be > than 32 bytes.
	Data			dd 8 dup (?)	; data peeking by DDESPY is limited to 32 bytes.
ends

struc	MONMSGSTRUCT
	cb			dd ?
	hwndTo			dd ?
	dwTime			dd ?
	hTask			dd ?
	wMsg			dd ?
	wParam			dd ?
	lParam			dd ?
	dmhd			DDEML_MSG_HOOK_DATA ? ; new for NT
ends

struc	MONCBSTRUCT
	cb			dd ?
	dwTime			dd ?
	hTask			dd ?
	dwRet			dd ?
	wType			dd ?
	wFmt			dd ?
	hConv			dd ?
	hsz1			dd ?
	hsz2			dd ?
	hData			dd ?
	dwData1 		dd ?
	dwData2 		dd ?
	cc			CONVCONTEXT ?	; new for NT for XTYP_CONNECT callbacks
	cbData			dd ?		; new for NT for data peeking
	Data			dd 8 dup (?)	; new for NT for data peeking
ends

struc	MONHSZSTRUCT
	cb			dd ?
	fsAction		dd ?		; MH_ value
	dwTime			dd ?
	hsz			dd ?
	hTask			dd ?
label	str			byte
ends

MH_CREATE			= 1
MH_KEEP 			= 2
MH_DELETE			= 3
MH_CLEANUP			= 4

struc	MONERRSTRUCT
	cb			dd ?
	wLastError		dd ?
	dwTime			dd ?
	hTask			dd ?
ends

struc	MONLINKSTRUCT
	cb			dd ?
	dwTime			dd ?
	hTask			dd ?
	fEstablished		dd ?
	fNoData 		dd ?
	hszSvc			dd ?
	hszTopic		dd ?
	hszItem 		dd ?
	wFmt			dd ?
	fServer 		dd ?
	hConvServer		dd ?
	hConvClient		dd ?
ends

struc	MONCONVSTRUCT
	cb			dd ?
	fConnect		dd ?
	dwTime			dd ?
	hTask			dd ?
	hszSvc			dd ?
	hszTopic		dd ?
	hConvClient		dd ?	     ; Globally unique value != apps local hConv
	hConvServer		dd ?	     ; Globally unique value != apps local hConv
ends

MAX_MONITORS			= 4
APPCLASS_MONITOR		= 000000001h
XTYP_MONITOR			= (000F0h + XCLASS_NOTIFICATION + XTYPF_NOBLOCK)

;
; Callback filter flags for use with MONITOR apps - 0 implies no monitor
; callbacks.
;
MF_HSZ_INFO			= 001000000h
MF_SENDMSGS			= 002000000h
MF_POSTMSGS			= 004000000h
MF_CALLBACKS			= 008000000h
MF_ERRORS			= 010000000h
MF_LINKS			= 020000000h
MF_CONV 			= 040000000h

MF_MASK 			= 0FF000000h
